## mingw-w64-quantum-espresso-7.4-2.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20 FATAL_ERROR)
# CMake < 3.13 cannot install external targets:
# https://gitlab.kitware.com/cmake/cmake/merge_requests/2152

# CMake < 3.14 generates incorrect dependency graphs with
# alias targets:
# https://gitlab.kitware.com/cmake/cmake/merge_requests/2521

# CMake < 3.20 does not support NVHPC compiler id
# https://cmake.org/cmake/help/latest/release/3.20.html#compilers

# Policy CMP0048: The project() command manages VERSION variables
set(CMAKE_POLICY_DEFAULT_CMP0048 NEW)

project(qe
    VERSION 7.4
    DESCRIPTION "ESPRESSO: opEn-Source Package for Research in Electronic Structure, Simulation, and Optimization"
    LANGUAGES Fortran C)

if(${qe_BINARY_DIR} STREQUAL ${qe_SOURCE_DIR})
    message(FATAL_ERROR "QE source folder cannot be safely used as a build folder!")
endif()

##########################################################
# Define the paths for static libraries and executables
##########################################################
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${qe_BINARY_DIR}/lib 
    CACHE
    PATH "Single output directory for building all libraries.")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${qe_BINARY_DIR}/bin 
    CACHE
    PATH "Single output directory for building all executables.")

###########################################################
# Build helpers
###########################################################
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
include(cmake/qeHelpers.cmake)

###########################################################
# Build Type
# Ensure that a specific, default build type is set when
# none has been explicitly set by the user
###########################################################
qe_ensure_build_type("Release")

###########################################################
# Modules
###########################################################
include(CheckFunctionExists)
# Must use GNUInstallDirs to install libraries into correct
# locations on all platforms.
include(GNUInstallDirs)

###########################################################
# Build Options
###########################################################
include(CMakeDependentOption)
option(QE_ENABLE_CUDA
    "enable CUDA acceleration on NVIDIA GPUs" OFF)
if(QE_ENABLE_CUDA)
    option(QE_ENABLE_OPENACC "enable OpenACC acceleration" ON)
    # OpenMP enabled by default if CUDA is enable
    option(QE_ENABLE_OPENMP
        "enable distributed execution support via OpenMP" ON)
else()
    option(QE_ENABLE_OPENACC "enable OpenACC acceleration" OFF)
    option(QE_ENABLE_OPENMP
        "enable distributed execution support via OpenMP" OFF)
endif()
cmake_dependent_option(QE_ENABLE_OFFLOAD
    "enable OpenMP offload"
    OFF "QE_ENABLE_OPENMP" OFF)
option(QE_ENABLE_MPI
    "enable distributed execution support via MPI" ON)
option(QE_ENABLE_MPI_GPU_AWARE
    "enable GPU aware MPI operations" OFF)
option(QE_ENABLE_TEST
    "enable unit and system tests" ON)
cmake_dependent_option(QE_ENABLE_BENCHMARK
    "enable benchmark tests" OFF "QE_ENABLE_TEST" OFF)
option(QE_ENABLE_TRACE
    "enable execution tracing output" OFF)
option(QE_ENABLE_PROFILE_NVTX
        "enable execution of NVIDIA NVTX profiler plugin" OFF)
option(QE_ENABLE_MPI_INPLACE
    "enable inplace MPI calls (ignored when QE_ENABLE_MPI=OFF)" OFF)
option(QE_ENABLE_BARRIER
    "enable global synchronization between execution units" OFF)
option(QE_LAPACK_INTERNAL
    "enable internal reference LAPACK" OFF)
option(QE_ENABLE_SCALAPACK
    "enable SCALAPACK execution units" OFF)
cmake_dependent_option(QE_ENABLE_SCALAPACK_QRCP
    "enable SCALAPACK QRCP in pw2wannier90 (requires SCALAPACK>=2.1.0 or Intel MKL>=2020)"
    OFF "QE_ENABLE_SCALAPACK" OFF)
option(QE_ENABLE_ELPA
    "enable ELPA execution units" OFF)
option(QE_ENABLE_LIBXC
    "enable LIBXC execution units" OFF)
option(QE_ENABLE_HDF5
    "enable HDF5 data collection" OFF)
option(QE_ENABLE_STATIC_BUILD
    "enable fully static build of executables" OFF)
option(QE_ENABLE_DOC
    "enable documentation building" OFF)
option(QE_CLOCK_SECONDS
    "print program time in seconds" OFF)
set(QE_FFTW_VENDOR "AUTO" CACHE
    STRING "select a specific FFTW library [Intel_DFTI, Intel_FFTW3, ArmPL, IBMESSL, FFTW3, Internal]")
set(QE_ENABLE_SANITIZER "none" CACHE STRING "none,asan,ubsan,tsan,msan")
set(QE_ENABLE_PLUGINS "" CACHE STRING "Semicolon-separated list of plugins")
set (QE_EXTRA_DEFINITIONS "" CACHE STRING "Semicolon-separated list of extra global definitions")
option(QE_ENABLE_FOX
    "enable XML I/O via Fox library" OFF)
if(QE_ENABLE_FOX)
    if(FOX_ROOT)
        set(QE_FOX_INTERNAL OFF)
    endif()
    option(QE_FOX_INTERNAL
        "enable FoX internal library" ON)
endif()

if(WANNIER90_ROOT)
    set(QE_WANNIER90_INTERNAL OFF)
endif()
option(QE_WANNIER90_INTERNAL
    "enable Wannier90 internal library" ON)
if(MBD_ROOT)
    set(QE_MBD_INTERNAL OFF)
endif()
option(QE_MBD_INTERNAL
    "enable LibMBD internal library" ON)
if(DEVICEXLIB_ROOT)
    set(QE_DEVICEXLIB_INTERNAL OFF)
endif()
option(QE_DEVICEXLIB_INTERNAL
    "enable DeviceXlib internal library" ON)
if(ENVIRON_ROOT)
    set(ENVIRON_DEFAULT "EXTERNAL")
else()
    set(ENVIRON_DEFAULT "NO")
endif()
set(QE_ENABLE_ENVIRON "${ENVIRON_DEFAULT}" CACHE
    STRING "select a specific Environ library [NO, EXTERNAL, INTERNAL]")

# OSCDFT
option(QE_ENABLE_OSCDFT "enable OS-CDFT 10.1021/acs.jctc.9b00281" OFF)


# TODO change all ifdefs throughout code base to match
# cmake options
# TODO symbols beginning with '__' followed by a capital
# character are reserved for standard library use (at
# least in C, not sure about Fortran), change all feature
# macros to avoid weird behaviors

if(QE_ENABLE_CUDA)
    qe_add_global_compile_definitions(__CUDA)
endif()
if(QE_ENABLE_TRACE)
    qe_add_global_compile_definitions(__TRACE)
endif()
if(QE_ENABLE_PROFILE_NVTX)
   qe_add_global_compile_definitions(__PROFILE_NVTX) 
endif() 
if(QE_ENABLE_MPI_INPLACE)
    qe_add_global_compile_definitions(__USE_INPLACE_MPI)
endif()
if(QE_ENABLE_BARRIER)
    qe_add_global_compile_definitions(__USE_BARRIER)
endif()
foreach(DEF IN LISTS QE_EXTRA_DEFINITIONS)
    qe_add_global_compile_definitions(${DEF})
endforeach()
if(QE_ENABLE_MPI)
    # OMPI_SKIP_MPICXX: skip CXX APIs on openmpi, cause trouble to C APIs
    qe_add_global_compile_definitions(__MPI OMPI_SKIP_MPICXX)
    if(QE_ENABLE_MPI_GPU_AWARE)
        qe_add_global_compile_definitions(__GPU_MPI)
    endif()
endif()
if(QE_ENABLE_SCALAPACK)
    qe_add_global_compile_definitions(__SCALAPACK)
endif()
if(QE_ENABLE_HDF5)
    qe_add_global_compile_definitions(__HDF5)
endif()
if(QE_ENABLE_ENVIRON)
    qe_add_global_compile_definitions(__ENVIRON)
endif()
if(QE_CLOCK_SECONDS)
   qe_add_global_compile_definitions(__CLOCK_SECONDS)
endif()

# OSCDFT
if(QE_ENABLE_OSCDFT)
    qe_add_global_compile_definitions(__OSCDFT)
endif()

# Check options consistency
if(QE_ENABLE_STATIC_BUILD AND BUILD_SHARED_LIBS)
    message(FATAL_ERROR "Full static build of QE executables requires static QE internal libraries. QE_ENABLE_STATIC_BUILD and BUILD_SHARED_LIBS cannot be both ON")
endif()
if(QE_ENABLE_ELPA AND NOT QE_ENABLE_SCALAPACK)
    message(FATAL_ERROR "ELPA requires SCALAPACK support, enable it with '-DQE_ENABLE_SCALAPACK=ON' or disable ELPA with '-DQE_ENABLE_ELPA=OFF'")
endif()
if(QE_ENABLE_SCALAPACK AND NOT QE_ENABLE_MPI)
    message(FATAL_ERROR "SCALAPACK requires MPI support, enable it with '-DQE_ENABLE_MPI=ON' or disable SCALAPACK with '-DQE_ENABLE_SCALAPACK=OFF'")
endif()
if(QE_ENABLE_CUDA AND NOT (CMAKE_Fortran_COMPILER_ID MATCHES "PGI" OR CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC"))
    message(FATAL_ERROR "NVHPC compiler is mandatory when CUDA is enabled due QE is based on CUDA Fortran language")
endif()
if(QE_ENABLE_OPENACC AND NOT (CMAKE_Fortran_COMPILER_ID MATCHES "PGI" OR CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC"))
    message(FATAL_ERROR "NVHPC compiler is mandatory when OpenACC is enabled")
endif()
if(QE_ENABLE_MPI_GPU_AWARE AND NOT (QE_ENABLE_CUDA AND QE_ENABLE_MPI))
    message(FATAL_ERROR "GPU aware MPI requires both MPI and CUDA features enabled")
endif()
# if(QE_ENABLE_HDF5 AND NOT QE_ENABLE_MPI)
#    message(FATAL_ERROR "HDF5 requires MPI support, enable it with '-DQE_ENABLE_MPI=ON' or disable HDF5 with '-DQE_ENABLE_HDF5=OFF'")
# endif()

# Add optional sanitizers ASAN, UBSAN, MSAN
set(VALID_SANITIZERS "none" "asan" "ubsan" "tsan" "msan")
# Perform sanitizer option check, only works in debug mode
if(NOT QE_ENABLE_SANITIZER IN_LIST VALID_SANITIZERS)
  message(FATAL_ERROR "Invalid -DQE_ENABLE_SANITIZER=${QE_ENABLE_SANITIZER}, value must be one of ${VALID_SANITIZERS}")
else()
  message(STATUS "Enable sanitizer QE_ENABLE_SANITIZER=${QE_ENABLE_SANITIZER}")
endif()
# only GNU works right now
if(NOT QE_ENABLE_SANITIZER STREQUAL "none" AND NOT CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
  message(FATAL_ERROR "-DQE_ENABLE_SANITIZER=${QE_ENABLE_SANITIZER} only works with the GNU compiler")
endif()

# valid plugins checks
set(VALID_QE_PLUGINS "d3q" "pw2qmcpack" "gipaw" "legacy")
# Perform sanitizer option check, only works in debug mode
foreach(PLUGIN IN LISTS QE_ENABLE_PLUGINS)
  if(NOT PLUGIN IN_LIST VALID_QE_PLUGINS)
    message(FATAL_ERROR "Invalid QE plugin ${PLUGIN}, value must be one of \"${VALID_QE_PLUGINS}\".")
  else()
    message(STATUS "Enable QE plugin ${PLUGIN}")
  endif()
endforeach()

############################################################
# C preprocessor
# Note: reply on the compiler preprocessor whenever possible
############################################################
if(DEFINED ENV{CPP})
    set(QE_CPP_DEFAULT $ENV{CPP})
else()
    set(QE_CPP_DEFAULT cpp)
endif()
# QE_CPP_DEFAULT is only effective when cached QE_CPP doesn't exist.
set(QE_CPP ${QE_CPP_DEFAULT} CACHE
    STRING "C preprocessor for qe_preprocess_source in qeHelpers.cmake")
find_program(QE_CPP_FULL_PATH NAMES ${QE_CPP} DOC "C preprocessor full path")
if(QE_CPP_FULL_PATH)
    message(STATUS "C preprocessor used by qe_preprocess_source in qeHelpers.cmake: ${QE_CPP_FULL_PATH}")
else()
    set(QE_CPP_SAVED ${QE_CPP})
    unset(QE_CPP CACHE)
    message(FATAL_ERROR "C preprocessor ${QE_CPP_SAVED} not found. Pass a working one to CMake via QE_CPP!")
endif()

###########################################################
# language standard requirements
###########################################################
# TODO need to require all compilers using the same one
if(CMAKE_Fortran_COMPILER_ID MATCHES "PGI" OR CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC")
    set(CMAKE_C_STANDARD 11)
    set(CMAKE_C_STANDARD_REQUIRED ON)
    set(CMAKE_C_EXTENSIONS OFF)
endif()

###########################################################
# check Fortran compiler -isystem option support
###########################################################
include(CheckFortranCompilerFlag)
check_fortran_compiler_flag("-isystem ." Fortran_ISYSTEM_SUPPORTED)
if(NOT Fortran_ISYSTEM_SUPPORTED AND NOT DEFINED CMAKE_NO_SYSTEM_FROM_IMPORTED)
  set(CMAKE_NO_SYSTEM_FROM_IMPORTED ON)
endif()

###########################################################
# OpenMP
# The following targets will be defined:
add_library(qe_openmp_fortran INTERFACE)
qe_install_targets(qe_openmp_fortran)
###########################################################
if(QE_ENABLE_OPENMP)
    find_package(OpenMP REQUIRED Fortran)
    target_link_libraries(qe_openmp_fortran INTERFACE OpenMP::OpenMP_Fortran)
endif(QE_ENABLE_OPENMP)
if(QE_ENABLE_OFFLOAD)
    target_compile_definitions(qe_openmp_fortran INTERFACE "$<$<COMPILE_LANGUAGE:Fortran>:__OPENMP_GPU>")
endif()

###########################################################
# OpenACC
# The following targets will be defined:
add_library(qe_openacc_fortran INTERFACE)
add_library(qe_openacc_c INTERFACE)
qe_install_targets(qe_openacc_fortran qe_openacc_c)
###########################################################

=== Makefile ===
# Copyright (C) 2001-2020 Quantum ESPRESSO Foundation
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License. See the file `License' in the root directory
# of the present distribution.

include make.inc

# execute a target irrespective of the presence of a file or directory 
# with the same name
.PHONY: install

default :
	@echo 'to install Quantum ESPRESSO, type at the shell prompt:'
	@echo '  ./configure [--prefix=]'
	@echo '  make [-j] target'
	@echo ' '
	@echo 'where target identifies one or multiple CORE PACKAGES:'
	@echo '  pw           basic code for scf, structure optimization, MD'
	@echo '  ph           phonon code, Gamma-only and third-order derivatives'
	@echo '  hp           calculation of the Hubbard parameters from DFPT'
	@echo '  pwcond       ballistic conductance'
	@echo '  neb          code for Nudged Elastic Band method'
	@echo '  pp           postprocessing programs'
	@echo '  pwall        same as "make pw ph pp pwcond neb"'
	@echo '  cp           CP code: Car-Parrinello molecular dynamics'
	@echo '  all_currents QEHeat code: energy flux and charge current'
	@echo '  tddfpt       time dependent dft code'
	@echo '  gwl          GW with Lanczos chains'
	@echo '  ld1          utilities for pseudopotential generation'
	@echo '  xspectra     X-ray core-hole spectroscopy calculations'
	@echo '  couple       Library interface for coupling to external codes'
	@echo '  epw          Electron-Phonon Coupling with Wannier functions'
	@echo '  kcw          KCW code: implementation of Koopmans functionals in primitive cell'
	@echo '  gui          Graphical User Interface'
	@echo '  all          same as "make pwall cp ld1 tddfpt xspectra hp"'
	@echo ' '
	@echo 'where target identifies one or multiple THIRD-PARTIES PACKAGES:'
	@echo '  gipaw        NMR and EPR spectra'
	@echo '  w90          Maximally localised Wannier Functions'
	@echo '  want         Quantum Transport with Wannier functions'
	@echo '  yambo        electronic excitations with plane waves'
	@echo '  d3q          general third-order code and thermal transport codes'
	@echo ' '
	@echo 'where target is one of the following suite operation:'
	@echo '  doc          build documentation'
	@echo '  links        create links to all executables in bin/'
	@echo '  install      copy all executables to PREFIX/bin/'
	@echo '               (works with "configure --prefix=PREFIX)"'
	@echo '  tar          create a tarball of the source tree'
	@echo '  depend       generate dependencies (make.depend files)'
	@if test -d GUI/; then \
		echo '  tar-gui      create a standalone PWgui tarball from the GUI sources'; \
		echo '  tar-qe-modes create a tarball for QE-modes (Emacs major modes for Quantum ESPRESSO)'; fi
	@echo '  clean        remove executables and objects'
	@echo '  veryclean    remove files produced by "configure" as well'
	@echo '  distclean    revert distribution to the original status'

###########################################################
# Main targets
###########################################################

# The syntax "( cd PW ; $(MAKE) TLDEPS= all || exit 1)" below
# guarantees that error code 1 is returned in case of error and make stops
# If "|| exit 1" is not present, the error code from make in subdirectories
# is not returned and make goes on even if compilation has failed

pw : pwlibs
	if test -d PW ; then \
	( cd PW ; $(MAKE) TLDEPS= all || exit 1) ; fi

cp : bindir mods
	if test -d CPV ; then \
	( cd CPV ; $(MAKE) TLDEPS= all || exit 1) ; fi

ph : phlibs
	if test -d PHonon; then \
	( cd PHonon; $(MAKE) TLDEPS= all || exit 1) ; fi

hp : hplibs
	if test -d HP; then \
	( cd HP; $(MAKE) TLDEPS= all || exit 1) ; fi

neb : pwlibs
	if test -d NEB; then \
	( cd NEB; $(MAKE) TLDEPS= all || exit 1) ; fi

tddfpt : lrmods
	if test -d TDDFPT; then \
	( cd TDDFPT; $(MAKE) TLDEPS= all || exit 1) ; fi

pp : pwlibs
	if test -d PP ; then \
	( cd PP ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

pwcond : pwlibs
	if test -d PWCOND ; then \
	( cd PWCOND ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

acfdt : phlibs
	if test -d ACFDT ; then \
	( cd ACFDT ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

gwl : phlibs
	if test -d GWW ; then \
	( cd GWW ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

gipaw : pwlibs
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

d3q : phlibs
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

ld1 : bindir mods
	if test -d atomic ; then \
	( cd atomic ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

xspectra : pwlibs
	if test -d XSpectra ; then \
	( cd XSpectra ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

couple : pw cp
	if test -d COUPLE ; then \
	( cd COUPLE ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

epw: phlibs w90lib pp
	if test -d EPW ; then \
	( cd EPW ; $(MAKE) all || exit 1; \
		cd ../bin; ln -fs ../EPW/bin/epw.x . ); fi

all_currents:
	if test -d QEHeat ; then \
	( cd QEHeat ; $(MAKE) all || exit 1; ) ; fi

travis : pwall epw
	if test -d test-suite ; then \
	( cd test-suite ; make run-travis || exit 1 ) ; fi

kcw : pwlibs lrmods pp w90lib
	if test -d KCW ; then \
	( cd KCW ; $(MAKE) all || exit 1 ) ; fi

gui : bindir
	@if test -d GUI/PWgui ; then \
	    cd GUI/PWgui ; \
	    $(MAKE) TLDEPS= init; \
	    echo ; \
	    echo "  ------------------------------------------------------------"; \
	    echo "  PWgui was built in ./GUI/PWgui/ and a link was made in bin/."; \
	    echo "  ------------------------------------------------------------"; \
	    echo "  Try it either as:  "; \
	    echo "         ./GUI/PWgui/pwgui" ; \
	    echo "     or"; \
	    echo "         ./bin/pwgui";\
	    echo ; \
	else \
	    echo ; \
	    echo "  Sorry, GUI/PWgui directory does not exist !" ; \
	    echo ; \
	fi

pwall : pw neb ph pp pwcond acfdt

all   : pwall cp ld1 tddfpt hp xspectra gwl kcw

###########################################################
# Auxiliary targets used by main targets:
# compile modules, libraries, directory for binaries, etc
###########################################################

pwlibs: bindir mods libks_solvers dftd3
	if test -d PW ; then \
	( cd PW ; $(MAKE) pw-lib || exit 1) ; fi

phlibs: pwlibs lrmods
	if test -d PHonon; then \
	( cd PHonon; $(MAKE) ph-lib || exit 1) ; fi

hplibs: pwlibs lrmods
	if test -d HP; then \
	( cd HP; $(MAKE) hp-lib || exit 1) ; fi

gwwlib : phlibs
	if test -d GWW ; then \
	( cd GWW ; $(MAKE) gwwa || exit 1 ) ; fi

pw4gwwlib : phlibs
	if test -d GWW ; then \
	( cd GWW ; $(MAKE) pw4gwwa || exit 1 ) ; fi

mods : $(FOX) libutil libla libfft libupf libmbd librxc
	( cd Modules ; $(MAKE) TLDEPS= all || exit 1 )

libks_solvers : libutil libla
	( cd KS_Solvers ; $(MAKE) TLDEPS= all || exit 1 )

libla : $(LAPACK) libutil libcuda
	( cd LAXlib ; $(MAKE) TLDEPS= all || exit 1 )

libfft : 
	( cd FFTXlib ; $(MAKE) TLDEPS= all || exit 1 )

librxc : 
	( cd XClib ; $(MAKE) TLDEPS= all || exit 1 )

libutil : 
	( cd UtilXlib ; $(MAKE) TLDEPS= all || exit 1 )

libupf : libutil libcuda
	( cd upflib ; $(MAKE) TLDEPS= all || exit 1 )

lrmods : mods pwlibs
	( cd LR_Modules ; $(MAKE) TLDEPS= all || exit 1 )

dftd3 : mods
	( cd dft-d3 ; $(MAKE) TLDEPS= all || exit 1 )

bindir :
	test -d bin || mkdir bin

#############################################################
# Targets for external libraries
############################################################

liblapack: 
	cd install ; $(MAKE) -f extlibs_makefile $@

libfox: 
	cd install ; $(MAKE) -f extlibs_makefile $@

libcuda: 
	cd install ; $(MAKE) -f extlibs_makefile $@

libmbd:
	cd install ; $(MAKE) -f extlibs_makefile $@

#########################################################
# plugins
#########################################################

w90: w90lib
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

w90lib: bindir $(LAPACK)
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

want: $(LAPACK)
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

yambo: $(LAPACK)
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

#########################################################
# "make links" produces links to all executables in bin/
#########################################################

# Contains workaround for name conflicts (dos.x and bands.x) with WANT
links : bindir
	( cd bin/ ; \
	rm -f *.x ; \
	for exe in ../*/*/*.x ../*/bin/* ; do \
	    if test ! -L $$exe ; then ln -fs $$exe . ; fi \
	done ; \
	[ -f ../WANT/wannier/dos.x ] && \
		ln -fs ../WANT/wannier/dos.x ../bin/dos_want.x ; \
	[ -f ../PP/src/dos.x ] &&  \
		ln -fs ../PP/src/dos.x ../bin/dos.x ; \
	[ -f ../WANT/wannier/bands.x ] && \
		ln -fs ../WANT/wannier/bands.x ../bin/bands_want.x ; \
	[ -f ../PP/src/dos.x ] &&  ln -fs ../PP/src/bands.x ../bin/bands.x ; \
	)

#############################################################
# 'make install' works with "configure --prefix=PREFIX"
# - If the PREFIX/bin directory does not exists it creates it
#############################################################

install : 
	mkdir -p $(PREFIX)/bin ; \
	for x in `find * ! -path "test-suite/*" -name *.x -type f` ; do \
		cp -v $$x $(PREFIX)/bin/ ; done
	@echo -e '\nQuantum ESPRESSO binaries are installed in $(PREFIX)/bin\n'

#########################################################
# Other targets: clean up
#########################################################

# remove object files and executables
clean : 
	touch make.inc 
	for dir in \
		CPV LAXlib FFTXlib XClib UtilXlib upflib Modules PP PW EPW KS_Solvers \
		NEB ACFDT COUPLE GWW XSpectra PWCOND dft-d3 \
		atomic LR_Modules upflib \
		dev-tools extlibs Environ TDDFPT PHonon HP GWW Doc GUI \
		QEHeat KCW \
	; do \
	    if test -d $$dir ; then \
		( cd $$dir ; \
		$(MAKE) TLDEPS= clean ) \
	    fi \
	done
	- @(cd install ; $(MAKE) -f plugins_makefile clean)
	- @(cd install ; $(MAKE) -f extlibs_makefile clean)
	- /bin/rm -rf bin/*.x tempdir

# remove files produced by "configure" as well
veryclean : clean
	- @(cd install ; $(MAKE) -f plugins_makefile veryclean)
	- @(cd install ; $(MAKE) -f extlibs_makefile veryclean)
	- (cd install ; rm -rf config.log configure.msg config.status \
		configure.h make_wannier90.inc autom4te.cache )
	- (cd include; rm -rf configure.in qe_cdefs.h )
	- rm -f espresso.tar.gz
	- rm -rf make.inc
	- rm -rf FoX
	- rm -rf MBD 
# remove everything not in the original distribution
distclean : veryclean
	- cd pseudo; ./clean_ps ; cd -
	- (cd install ; $(MAKE) -f plugins_makefile $@)
	- git submodule deinit --all --force # place deinit at the very end such that makefiles clean up as much as possible.

tar :
	@if test -f espresso.tar.gz ; then /bin/rm espresso.tar.gz ; fi
	# do not include unneeded stuff 
	find ./ -type f | grep -v -e /.svn/ -e'/\.' -e'\.o$$' -e'\.mod$$'\
		-e /.git/ -e'\.a$$' -e'\.d$$' -e'\.i$$' -e'_tmp\.f90$$' -e'\.x$$' \
		-e'~$$' -e'\./GUI' -e '\./tempdir' | xargs tar rvf espresso.tar
	gzip espresso.tar

#########################################################
# Tools for the developers
#########################################################
tar-gui :
	@if test -d GUI/PWgui ; then \
	    cd GUI/PWgui ; \
	    $(MAKE) TLDEPS= clean init pwgui-source; \
	    mv PWgui-*.tgz ../.. ; \
	else \
	    echo ; \
	    echo "  Sorry, tar-gui works only for git sources !!!" ; \
	    echo ; \
	fi

tar-qe-modes :
	@if test -d GUI/QE-modes ; then \
	    cd GUI/QE-modes ; \
	    $(MAKE) TLDEPS= veryclean tar; \
	    mv QE-modes-*.tar.gz ../.. ; \
	else \
	    echo ; \
	    echo "  Sorry, tar-qe-modes works only for git sources !!!" ; \
	    echo ; \
	fi

# NOTICE about "make doc": in order to build the .html and .txt
# documentation in Doc, "tcl", "tcllib", "xsltproc" are needed;
# in order to build the .pdf files in Doc, "pdflatex" is needed;
# in order to build html files for the user guide,
# "latex2html" and "convert" (from Image-Magick) are needed.
doc : 
	if test -d Doc ; then \

=== EPW/CMakeLists.txt ===
set(sources
    src/input.f90
    src/ep_constants.f90
    src/global_var.f90
    src/io/io_var.f90
    src/bloch2wannier.f90
    src/utilities/low_lvl.f90
    src/utilities/parallelism.f90
    src/longrange.f90
    src/io/io.f90
    src/io/io_transport.f90
    src/io/io_selfen.f90
    src/wigner.f90
    src/wannier2bloch.f90
    src/wannier2bloch_opt.f90
    src/cumulant.f90
    src/close.f90
    src/printing.f90
    src/utilities/kfold.f90
    src/utilities/bzgrid.f90
    src/io/io_supercond.f90
    src/utilities/utilities.f90
    src/supercond_common.f90
    src/supercond.f90
    src/supercond_iso.f90
    src/supercond_aniso.f90
    src/supercond_coul.f90
    src/utilities/sparse_ir.f90
    src/io/io_sparse_ir.f90
    src/stop.f90
    src/transport_mag.f90
    src/utilities/symmetry.f90
    src/transport_legacy.f90
    src/transport.f90
    src/pw2wan.f90
    src/wannierization.f90
    src/indabs.f90
    src/io/io_indabs.f90
    src/utilities/bcast_input.f90
    src/io/io_ahc.f90
    src/dvqpsi.f90
    src/ep_coarse.f90
    src/ep_coarse_unfolding.f90
    src/supercond_driver.f90
    src/selfen.f90
    src/spectral.f90
    src/wannier.f90
    src/use_wannier.f90
    src/init.f90
    src/readin.f90
    src/setups.f90
    src/summaries.f90
    src/wann_common.f90
    src/polaron.f90
    src/qdabs.f90
    src/wfpt.f90
    src/utilities/screening.f90
    )

qe_add_library(qe_epw ${sources})
target_link_libraries(
    qe_epw
    PRIVATE qe_wannier90
            qe_modules
            qe_lr_modules
            qe_phonon_ph
            qe_pw
            qe_mpi_fortran
            qe_upflib
            qe_fftx
            qe_elpa
            qe_xclib)

###########################################################
# epw.x
###########################################################
set(sources src/epw.f90)
qe_add_executable(qe_epw_exe ${sources})
set_target_properties(qe_epw_exe PROPERTIES OUTPUT_NAME epw.x)
target_link_libraries(qe_epw_exe PRIVATE qe_modules qe_pw qe_fftx qe_epw qe_upflib)

###########################################################
# nscf2supercond.x
###########################################################
set(sources src/utilities/nscf2supercond.f90)
qe_add_executable(qe_epw_nscf2supercond_exe ${sources})
set_target_properties(qe_epw_nscf2supercond_exe PROPERTIES OUTPUT_NAME nscf2supercond.x)
target_link_libraries(qe_epw_nscf2supercond_exe PRIVATE qe_pw qe_modules qe_pp qe_upflib)

###########################################################
# ZG.x
###########################################################
set(sources ZG/src/ZG.f90)
qe_add_executable(qe_zg_exe ${sources})
set_target_properties(qe_zg_exe PROPERTIES OUTPUT_NAME ZG.x)
target_link_libraries(qe_zg_exe PRIVATE qe_modules qe_pw qe_phonon_ph qe_lr_modules qe_lapack)

###########################################################
# disca.x
###########################################################
set(sources ZG/src/disca.f90)
qe_add_executable(qe_zg_disca_exe ${sources})
set_target_properties(qe_zg_disca_exe PROPERTIES OUTPUT_NAME disca.x)
target_link_libraries(qe_zg_disca_exe PRIVATE qe_modules qe_pw qe_phonon_ph qe_lr_modules qe_lapack)

###########################################################
# pp_disca.x
###########################################################
set(sources ZG/src/pp_disca.f90)
qe_add_executable(qe_zg_pp_disca_exe ${sources})
set_target_properties(qe_zg_pp_disca_exe PROPERTIES OUTPUT_NAME pp_disca.x)
target_link_libraries(qe_zg_pp_disca_exe PRIVATE qe_modules qe_lr_modules qe_lapack)

###########################################################
# bands_unfold.x
###########################################################
set(src_bands_unfold_x ZG/src/bands_unfold.f90)
qe_add_executable(qe_zg_bands_unfold_exe ${sources})
set_target_properties(qe_zg_bands_unfold_exe PROPERTIES OUTPUT_NAME bands_unfold.x)
target_link_libraries(qe_zg_bands_unfold_exe PRIVATE qe_pw qe_modules qe_pp qe_upflib)

###########################################################
# pp_spctrlfn.x
###########################################################
set(sources ZG/src/pp_spctrlfn.f90)
qe_add_executable(qe_zg_pp_spctrlfn_exe ${sources})
set_target_properties(qe_zg_pp_spctrlfn_exe PROPERTIES OUTPUT_NAME pp_spctrlfn.x)
target_link_libraries(qe_zg_pp_spctrlfn_exe PRIVATE qe_modules qe_lr_modules qe_lapack)

###########################################################
# epsilon_Gaus.x
###########################################################
set(src_epsilon_Gaus_x ZG/src/epsilon_Gaus.f90)
qe_add_executable(qe_zg_epsilon_Gaus_exe ${sources})
set_target_properties(qe_zg_epsilon_Gaus_exe PROPERTIES OUTPUT_NAME epsilon_Gaus.x)
target_link_libraries(qe_zg_epsilon_Gaus_exe PRIVATE qe_pw qe_modules qe_pp qe_upflib)

###########################################################

qe_install_targets(
    # Libraries
    qe_epw
    # Exacutables
    qe_epw_exe qe_zg_exe qe_zg_disca_exe qe_zg_pp_disca_exe qe_zg_bands_unfold_exe qe_zg_pp_spctrlfn_exe qe_zg_epsilon_Gaus_exe)

install(PROGRAMS bin/pp.py TYPE BIN RENAME epw_pp.py)

add_custom_target(epw
    DEPENDS
        qe_epw_exe
    COMMENT
        "electron-Phonon Coupling with wannier functions")

=== EPW/Makefile ===
# Makefile for EPW
sinclude ../make.inc

default: epw

all: epw

epw: 
	(cd src ; make all )
	- (mkdir -p bin)
	(cd bin ; ln -fs ../src/epw.x . )
	(cd ZG/src ; make )

clean:
	(cd src ; make clean )
	(cd ZG/src ; make clean )

distclean : clean
	rm -f src/epw.x bin/epw.x
	rm -f src/nscf2supercond.x bin/nscf2supercond.x
	rm -f ZG/src/*.x

release:
	cd ../ ; cp -r EPW EPW-release; cd EPW-release ; \
	rm -f src/*.o src/*.mod src/*.F90 src/*~ ; \
	rm bin/*.x ; \
	rm -rf examples/*/epw/out/* examples/*/epw/tmp/* \
	 examples/*/phonons/out/* examples/*/phonons/tmp/* \
	 examples/*/phonons/save/* ; \
	cd .. ; tar cfz EPW/EPW-release.tgz EPW-release ; \
	rm -rf EPW-release ; cd EPW

=== HP/CMakeLists.txt ===
set(src_hp
    src/hp_allocate_q.f90
    src/hp_bcast_input.f90
    src/hpcom.f90
    src/hp_clean_q.f90
    src/hp_close_q.f90
    src/hp_calc_chi.f90
    src/hp_check_pert.f90
    src/hp_check_type.f90
    src/hp_dnstot_sum_q.f90
    src/hp_dnsq.f90
    src/hp_dealloc_q.f90
    src/hp_dealloc_1.f90
    src/hp_dealloc_2.f90
    src/hp_dvpsi_pert.f90
    src/hp_find_inequiv_sites.f90
    src/hp_generate_grids.f90
    src/hp_init.f90
    src/hp_init_q.f90
    src/hp_load_q.f90
    src/hp_ns_trace.f90
    src/hp_openfil_q.f90
    src/hp_psym_dmag.f90
    src/hp_psymdvscf.f90
    src/hp_postproc.f90
    src/hp_prepare_q.f90
    src/hp_print_clock.f90
    src/hp_q_points.f90
    src/hp_R_points.f90
    src/hp_rotate_dnsq.f90
    src/hp_readin.f90
    src/hp_read_chi.f90
    src/hp_read_dnsq.f90
    src/hp_run_nscf.f90
    src/hp_solve_linear_system.f90
    src/hp_symdnsq.f90
    src/hp_sym_dmag.f90
    src/hp_symdvscf.f90
    src/hp_setup_q.f90
    src/hp_summary.f90
    src/hp_summary_q.f90
    src/hp_stop_smoothly.f90
    src/hp_write_chi.f90
    src/hp_write_chi_full.f90
    src/hp_write_dnsq.f90)

qe_add_library(qe_hp ${src_hp})
target_link_libraries(qe_hp
    PRIVATE
        qe_pw
        qe_lr_modules
        qe_modules
        qe_fftx
        qe_upflib
        qe_xclib)

###########################################################
# hp.x
###########################################################
set(src_hp_x src/hp_main.f90)
qe_enable_cuda_fortran("${src_hp_x}")
qe_add_executable(qe_hp_exe ${src_hp_x})
set_target_properties(qe_hp_exe 
    PROPERTIES 
        OUTPUT_NAME hp.x)
target_link_libraries(qe_hp_exe
    PRIVATE
        qe_pw
        qe_lax
        qe_modules
        qe_hp
        qe_xclib)

###########################################################

qe_install_targets(
    qe_hp
    qe_hp_exe)

add_custom_target(hp
    DEPENDS
        qe_hp_exe
    COMMENT
        "calculation of the Hubbard parameters from DFPT")

=== KCW/Makefile ===
# Makefile for KCW
sinclude ../make.inc

default: all

all: kcw pp

kcw: kcw-lib
	( cd src ; $(MAKE) all || exit 1 )

kcw-lib:
	( cd src ; $(MAKE) libs-kcw || exit 1 )

pp: kcw-lib
	( cd PP ; $(MAKE) all || exit 1 )

clean: kcw_clean pp_clean

kcw_clean:
	( cd src ; $(MAKE) clean )

pp_clean:
	( cd PP ; $(MAKE) clean )

doc:
	if test -d Doc ; then \
	( cd Doc ; $(MAKE) all || exit 1 ) ; fi

doc_clean:
	if test -d Doc ; then \
	(cd Doc ; $(MAKE) clean ) ; fi

distclean: clean doc_clean

=== KS_Solvers/CMakeLists.txt ===
set(ks_headers
  ks_solver_interfaces.h)
set (ks_include_dir ${CMAKE_CURRENT_BINARY_DIR}/include)
#FIXME maybe better to move this part to an helper function 
foreach (in_h ${ks_headers})
  get_filename_component(in_h_basename ${in_h} NAME_WE)
  set (out_h "${ks_include_dir}/${in_h_basename}.fh")
  qe_preprocess_source("${CMAKE_CURRENT_SOURCE_DIR}/${in_h}" ${out_h})
  list (APPEND ks_out_headers ${out_h})
endforeach()
add_custom_target(qe_ks_headers 
  DEPENDS ${ks_out_headers}
  VERBATIM )

set(src_davidson
    Davidson_RCI/david_rci.f90
    Davidson/cegterg.f90
    Davidson/regterg.f90
    # GPU
    Davidson/regterg_gpu.f90
    Davidson/cegterg_gpu.f90)
qe_enable_cuda_fortran("${src_davidson}")

set(src_davidson_rci
    Davidson_RCI/david_rci.f90)

set(src_cg
    CG/ccgdiagg.f90
    CG/rcgdiagg.f90
    # GPU
    CG/rcgdiagg_gpu.f90
    CG/ccgdiagg_gpu.f90)
qe_enable_cuda_fortran("${src_cg}")

set(src_ppcg
    PPCG/ppcg_gamma.f90
    PPCG/ppcg_k.f90
    # GPU
    PPCG/ppcg_gamma_gpu.f90
    PPCG/ppcg_k_gpu.f90
    PPCG/generic_cublas.f90)
qe_enable_cuda_fortran("${src_ppcg}")

set(src_dense
    DENSE/rotate_HSpsi_gamma.f90
    DENSE/rotate_HSpsi_k.f90
    DENSE/rotate_wfc_gamma.f90
    DENSE/rotate_wfc_k.f90 
    DENSE/rotate_xpsi_k.f90
    DENSE/rotate_xpsi_gamma.f90
    DENSE/gram_schmidt_k.f90
    DENSE/gram_schmidt_gamma.f90
    DENSE/rotate_driver.f90
    # GPU
    DENSE/rotate_wfc_gamma_gpu.f90
    DENSE/rotate_xpsi_k_gpu.f90
    DENSE/rotate_xpsi_gamma_gpu.f90
    DENSE/gram_schmidt_k_gpu.f90
    DENSE/gram_schmidt_gamma_gpu.f90
    DENSE/rotate_wfc_k_gpu.f90
    DENSE/rotate_driver_cuf.f90)
qe_enable_cuda_fortran("${src_dense}")

set(src_paro
    ParO/bpcg_gamma.f90
    ParO/bpcg_k.f90
    ParO/paro_gamma.f90
    ParO/pcg_gamma.f90
    ParO/paro_k.f90
    ParO/pcg_k.f90
    ParO/paro_gamma_new.f90
    ParO/paro_k_new.f90)
qe_enable_cuda_fortran("${src_paro}")

set(src_rmmdiis
    RMM/crmmdiagg.f90 
    RMM/rrmmdiagg.f90 
    # GPU
    RMM/crmmdiagg_gpu.f90
    RMM/rrmmdiagg_gpu.f90)
    qe_enable_cuda_fortran("${src_rmmdiis}")

qe_add_library(qe_kssolver_davidson ${src_davidson})
target_link_libraries(qe_kssolver_davidson
    PRIVATE
        qe_device_lapack
        qe_openacc_fortran
        qe_openmp_fortran
        qe_lax
        qe_utilx
        qe_mpi_fortran
        qe_devxlib)

qe_add_library(qe_kssolver_davidsonrci ${src_davidson_rci})
target_link_libraries(qe_kssolver_davidsonrci
    PRIVATE
        qe_lax
        qe_utilx
        qe_mpi_fortran)

qe_add_library(qe_kssolver_cg ${src_cg})
target_link_libraries(qe_kssolver_cg
    PRIVATE
        qe_lax
        qe_openacc_fortran
        qe_utilx
        qe_mpi_fortran
        qe_devxlib)

qe_add_library(qe_kssolver_ppcg ${src_ppcg})
target_link_libraries(qe_kssolver_ppcg
    PRIVATE
        qe_scalapack
        qe_openacc_fortran
        qe_openmp_fortran
        qe_lax
        qe_utilx
        qe_mpi_fortran)

qe_add_library(qe_kssolver_dense ${src_dense})
target_link_libraries(qe_kssolver_dense
    PRIVATE
        qe_openacc_fortran
        qe_lax
        qe_utilx
        qe_mpi_fortran
        qe_devxlib)
target_include_directories(qe_kssolver_dense
  PUBLIC
    $<BUILD_INTERFACE:${ks_include_dir}>
    $<INSTALL_INTERFACE:include/qe>
)
set_target_properties(qe_kssolver_dense
  PROPERTIES PUBLIC_HEADER ${ks_out_headers}
)
add_dependencies(qe_kssolver_dense qe_ks_headers)

qe_add_library(qe_kssolver_paro ${src_paro})
target_link_libraries(qe_kssolver_paro
    PRIVATE 
        qe_device_lapack
        qe_openacc_fortran
        qe_kssolver_dense
        qe_lax
        qe_utilx
        qe_mpi_fortran)

qe_add_library(qe_kssolver_rmmdiis ${src_rmmdiis})
target_link_libraries(qe_kssolver_rmmdiis
    PRIVATE
	qe_lax
        qe_openacc_fortran
        qe_utilx
	qe_devxlib
        qe_mpi_fortran )  

###########################################################

qe_install_targets(
    qe_kssolver_davidson
    qe_kssolver_davidsonrci
    qe_kssolver_cg
    qe_kssolver_ppcg
    qe_kssolver_paro
    qe_kssolver_dense
    qe_kssolver_rmmdiis)

=== KS_Solvers/Makefile ===
# Makefile for  KS_Solvers
include ../make.inc

# the following directive prevents execution of this makefile in parallel
# Problem is, libks_solvers.a depends upon all libdavid libcg etc, but if
# those dependencies are added explicitly to libks_solvers.a, the library
# is relinked every time, forcing relinking of many executables; if not, 
# parallel make may execute libks_solvers.a before all other lib* complete 
.NOTPARALLEL :

default: all

all: libdavid_rci libdavid libcg libppcg libparo librmm libdense libnewsolver libks_solvers.a ks_solver_interfaces.fh

ALLOBJS = \
Davidson_RCI/david_rci.o \
Davidson/cegterg.o \
Davidson/regterg.o \
CG/ccgdiagg.o \
CG/rcgdiagg.o \
PPCG/generic_cublas.o \
PPCG/ppcg_gamma.o \
PPCG/ppcg_k.o \
ParO/bpcg_gamma.o \
ParO/bpcg_k.o \
ParO/paro_gamma.o \
ParO/pcg_gamma.o \
ParO/paro_k.o \
ParO/pcg_k.o \
ParO/paro_gamma_new.o \
ParO/paro_k_new.o \
DENSE/rotate_HSpsi_gamma.o \
DENSE/rotate_HSpsi_k.o \
DENSE/rotate_wfc_gamma.o \
DENSE/rotate_wfc_k.o \
DENSE/rotate_driver.o \
DENSE/gram_schmidt_gamma.o \
DENSE/gram_schmidt_k.o \
DENSE/gram_schmidt_k_gpu.o \
DENSE/gram_schmidt_gamma_gpu.o \
DENSE/rotate_xpsi_gamma.o \
DENSE/rotate_xpsi_gamma_gpu.o \
DENSE/rotate_xpsi_k_gpu.o \
DENSE/rotate_xpsi_k.o \
RMM/crmmdiagg.o \
RMM/crmmdiagg_gpu.o \
RMM/rrmmdiagg.o \
RMM/rrmmdiagg_gpu.o 


# GPU-related objects
ALLOBJS += \
Davidson/cegterg_gpu.o \
Davidson/regterg_gpu.o \
DENSE/rotate_wfc_k_gpu.o \
DENSE/rotate_wfc_gamma_gpu.o \
DENSE/rotate_driver_cuf.o \
CG/rcgdiagg_gpu.o \
CG/ccgdiagg_gpu.o \
PPCG/generic_cublas.o \
PPCG/ppcg_gamma_gpu.o \
PPCG/ppcg_k_gpu.o 

# add here other objects, e.g. ParO/*.o NewSolver/*.o

libks_solvers.a: $(ALLOBJS) 
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@



libdavid_rci : 
	if test -d Davidson_RCI ; then \
	( cd Davidson_RCI ; $(MAKE) all || exit 1 ) ; fi

libdavid : 
	if test -d Davidson ; then \
        ( cd Davidson ; $(MAKE) all || exit 1 ) ; fi

libcg : 
	if test -d CG ; then \
        ( cd CG ; $(MAKE) all || exit 1 ) ; fi

libppcg : 
	if test -d PPCG ; then \
        ( cd PPCG ; $(MAKE) all || exit 1 ) ; fi

libparo : 
	if test -d ParO ; then \
        ( cd ParO ; $(MAKE) all || exit 1 ) ; fi

librmm : 
	if test -d RMM ; then \
        ( cd RMM ; $(MAKE) all || exit 1 ) ; fi

libdense : 
	if test -d DENSE ; then \
        ( cd DENSE ; $(MAKE) all || exit 1 ) ; fi

librmm :
	if test -d RMM ; then \
        ( cd RMM ; $(MAKE) all || exit 1 ) ; fi

libnewsolver : 
	if test -d NewSolver ; then \
        ( cd NewSolver ; $(MAKE) all || exit 1 ) ; fi

clean : 
	if test -d Davidson_RCI ; then ( cd Davidson_RCI ; $(MAKE) clean ) ; fi
	if test -d Davidson     ; then ( cd Davidson ; $(MAKE) clean ) ; fi
	if test -d CG           ; then ( cd CG ; $(MAKE) clean ) ; fi
	if test -d PPCG         ; then ( cd PPCG ; $(MAKE) clean ) ; fi
	if test -d ParO         ; then ( cd ParO ; $(MAKE) clean ) ; fi
	if test -d RMM          ; then ( cd RMM ; $(MAKE) clean ) ; fi
	if test -d DENSE        ; then ( cd DENSE ; $(MAKE) clean ) ; fi
	if test -d RMM          ; then ( cd RMM ; $(MAKE) clean ) ; fi
	if test -d NewSolver    ; then ( cd NewSolver ; $(MAKE) clean ) ; fi
	rm -f *.fh 
	rm -f libks_solvers.a

=== LAXlib/CMakeLists.txt ===
set(src_lax
    distools.f90
    dspev_drv.f90
    la_error.f90
    la_helper.f90
    la_param.f90
    la_types.f90
    mp_diag.f90
    ptoolkit.f90
    rdiaghg.f90
    transto.f90
    zhpev_drv.f90
    cdiaghg.f90)
qe_enable_cuda_fortran("${src_lax}")

qe_add_library(qe_lax ${src_lax})
target_link_libraries(qe_lax
    PRIVATE
        qe_elpa
        qe_lapack
        qe_scalapack
        qe_openmp_fortran
        qe_mpi_fortran
        qe_utilx
        qe_devxlib)
if(QE_ENABLE_CUDA)
    if(CMAKE_Fortran_COMPILER_ID MATCHES "PGI" OR CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC")
        set(CMAKE_REQUIRED_LINK_OPTIONS "${CUDA_FLAG}lib=cusolver;-fortranlibs")
        check_function_exists(cusolverDnZhegvdx cusolverDnZhegvdx_FOUND)
        if (NOT cusolverDnZhegvdx_FOUND)
            unset(cusolverDnZhegvdx_FOUND CACHE)
            message(FATAL_ERROR "The version of CUDAToolkit chosen by the PGI/NVHPC compiler internally"
                                " doesn't contain cusolverDnZhegvdx. cuSOLVER features used by LAXLib are"
                                " only supported since CUDAToolkit 10.1 release. Use a newer compiler"
                                " or select a newer CUDAToolkit internal to the PGI/NVHPC compiler.")
        endif()
    else()
        if(CUDAToolkit_VERSION VERSION_LESS 10.1)
            message(FATAL_ERROR "cuSOLVER for LAXLib is only supported from CUDA compiler 10.1")
        endif()
    endif()
    target_link_libraries(qe_lax
        PRIVATE
            CUDA::cusolver
            CUDA::cublas)
endif()

# LAX relies on header files that should be preprocessed
# and renamed *.h -> *.fh due to the fact that those
# headers use preprocessor directives but they are included 
# via fortran 'include' statements that are managed by the
# compiler frontend long after the actual C preprocessor has run.
set(in_headers
    laxlib.h
    laxlib_hi.h
    laxlib_kinds.h
    laxlib_low.h
    laxlib_mid.h
    laxlib_param.h)
set(lax_include_dir ${CMAKE_CURRENT_BINARY_DIR}/include)
foreach(in_h ${in_headers})
    get_filename_component(in_h_basename ${in_h} NAME_WE)
    set(out_h "${lax_include_dir}/${in_h_basename}.fh")
    qe_preprocess_source(${CMAKE_CURRENT_SOURCE_DIR}/${in_h} ${out_h})
    list(APPEND out_headers ${out_h})
endforeach()
add_custom_target(qe_lax_headers
    DEPENDS ${out_headers}
    VERBATIM)
target_include_directories(qe_lax
    PUBLIC
        $<BUILD_INTERFACE:${lax_include_dir}>
        $<INSTALL_INTERFACE:include/qe>)
set_target_properties(qe_lax
    PROPERTIES PUBLIC_HEADER "${out_headers}")
add_dependencies(qe_lax qe_lax_headers)

qe_install_targets(qe_lax)

###########################################################
# Tests
# TODO move all tests to a proper location
###########################################################
if(QE_ENABLE_TEST)
    set(src_lax_test test.f90)
    qe_enable_cuda_fortran("${src_lax_test}")
    qe_add_executable(qe_lax_test ${src_lax_test})
    set_target_properties(qe_lax_test 
        PROPERTIES 
            OUTPUT_NAME qe_lax_test.x 
            RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin)
    target_link_libraries(qe_lax_test
        PRIVATE
            qe_mpi_fortran
            qe_lax
            qe_lapack)
    add_unit_test(test_qe_lax-r1-t1 1 1 $<TARGET_FILE:qe_lax_test>)
    add_unit_test(test_qe_lax-r1-t3 1 3 $<TARGET_FILE:qe_lax_test>)
    add_unit_test(test_qe_lax-r4-t1 4 1 $<TARGET_FILE:qe_lax_test>)
    add_unit_test(test_qe_lax-r9-t2 9 2 $<TARGET_FILE:qe_lax_test>)

    add_subdirectory(tests)
endif(QE_ENABLE_TEST)

=== LR_Modules/CMakeLists.txt ===
set(sources
    adddvscf.f90
    adddvhubscf.f90
    addusdbec.f90
    addusdbec_nc.f90
    apply_dpot.f90
    apply_dpot_mod.f90
    apply_trev.f90
    non_scf_ph.f90
    c_bands_ph.f90
    addusldos.f90
    adddvepsi_us.f90
    cft_wave.f90
    cgsolve_all.f90
    cg_psi.f90
    ch_psi_all.f90
    Coul_cut_2D_ph.f90
    check_q_points_sym.f90
    dfpt_tetra_mod.f90
    dynmat_sub.f90
    h_prec.f90
    incdrhoscf.f90
    incdrhoscf_nc.f90
    dv_of_drho.f90
    dgradcorr.f90
    dnonloccorr.f90
    dv_vdW_DF.f90
    dv_rVV10.f90
    newdq.f90
    orthogonalize.f90
    setup_nscf.f90
    set_dbecsum_nc.f90
    set_int3_nc.f90
    smallgq.f90
    lr_sm1_psi.f90
    lr_addusddens.f90
    lr_two_chem.f90
    localdos.f90
    setup_dgc.f90
    compute_vsgga.f90
    setup_dmuxc.f90
    setup_nbnd_occ.f90
    setup_alpha_pv.f90
    set_small_group_of_q.f90
    sgam_lr.f90
    star_q.f90
    setqmod.f90
    lr_orthoUwfc.f90
    qdipol_cryst.f90
    mode_group.f90
    mix_pot.f90
    lrcom.f90
    lr_dot.f90
    lr_dot_magnons.f90
    lr_nc_mag.f90
    lanczos_pseudohermitian.f90
    lanczos_nonhermitian.f90
    lanczos_pseudohermitian_c.f90
    lanczos_nonhermitian_c.f90
    set_kplusq_nc.f90
    lr_sym_mod.f90
    ccg_psi.f90
    ccgsolve_all.f90
    ch_psi_all_complex.f90
    addusddenseq.f90
    response_kernels.f90
    efermi_shift.f90)
qe_enable_cuda_fortran("${sources}")
qe_add_library(qe_lr_modules ${sources})
target_link_libraries(qe_lr_modules
    PRIVATE
        qe_openacc_fortran
	qe_openmp_fortran
	qe_mpi_fortran
        qe_modules
        qe_pw
        qe_upflib
        qe_fftx
        qe_xclib
	qe_device_lapack)

if(QE_ENABLE_CUDA)
    target_link_libraries(qe_modules
        PRIVATE
            CUDA::cublas)
endif()

###########################################################

qe_install_targets(qe_lr_modules)

=== LR_Modules/Makefile ===
# Makefile for LR_Modules

include ../make.inc

# location of needed modules and included files (if any)
MODFLAGS=$(BASEMOD_FLAGS) $(MOD_FLAG)$(TOPDIR)/PW/src

LR_MODULES = \
adddvscf.o \
adddvhubscf.o \
addusdbec.o \
addusdbec_nc.o \
apply_dpot.o \
apply_dpot_mod.o \
apply_trev.o \
addusldos.o \
adddvepsi_us.o \
addusddenseq.o \
c_bands_ph.o \
cft_wave.o \
cgsolve_all.o \
ccgsolve_all.o \
cg_psi.o \
ccg_psi.o \
c_bands_ph.o \
ch_psi_all.o \
ch_psi_all_complex.o \
Coul_cut_2D_ph.o \
check_q_points_sym.o \
dfpt_tetra_mod.o \
dynmat_sub.o \
h_prec.o \
incdrhoscf.o \
incdrhoscf_nc.o \
dv_of_drho.o \
dgradcorr.o \
dnonloccorr.o \
dv_vdW_DF.o \
dv_rVV10.o \
newdq.o \
non_scf_ph.o \
set_intq_nc.o \
lr_sym_mod.o \
orthogonalize.o \
setup_nscf.o \
set_dbecsum_nc.o \
set_int3_nc.o \
set_kplusq_nc.o \
smallgq.o \
lr_sm1_psi.o \
lr_addusddens.o \
localdos.o \
setup_dgc.o \
compute_vsgga.o \
setup_dmuxc.o \
setup_nbnd_occ.o \
setup_alpha_pv.o \
set_small_group_of_q.o \
sgam_lr.o \
star_q.o \
setqmod.o \
lr_orthoUwfc.o \
qdipol_cryst.o \
mode_group.o \
mix_pot.o \
lrcom.o \
lr_dot.o \
lr_dot_magnons.o \
lr_nc_mag.o \
lr_two_chem.o\
lanczos_nonhermitian.o \
lanczos_pseudohermitian.o \
lanczos_pseudohermitian_c.o \
lanczos_nonhermitian_c.o \
response_kernels.o \
non_scf_ph.o \
efermi_shift.o

TLDEPS=mods pwlibs

all : liblrmod.a

liblrmod.a: $(LR_MODULES)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

tldeps :
	if test -n "$(TLDEPS)" ; then \
	( cd ../; $(MAKE) $(TLDEPS) || exit 1 ) ; fi

clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L

include make.depend

=== Modules/CMakeLists.txt ===
set(src_modules
    additional_kpoints.f90 
    atomic_wfc_mod.f90
    autopilot.f90 
    basic_algebra_routines.f90 
    becmod.f90 
    bfgs_module.f90 
    bspline.f90 
    bz_form.f90 
    cell_base.f90  
    check_stop.f90  
    command_line_options.f90 
    compute_dipole.f90 
    constants.f90 
    constraints_module.f90 
    control_flags.f90 
    coulomb_vcut.f90  
    dist.f90 
    electrons_base.f90 
    environ_base_module.f90
    environment.f90 
    extffield.f90
    fd_gradient.f90 
    fft_base.f90 
    fft_rho.f90 
    fft_wave.f90 
    fsockets.f90 
    funct.f90 
    generate_function.f90 
    gradutils.f90 
    gvecw.f90 
    input_parameters.f90 
    invmat.f90 
    io_files.f90 
    io_global.f90  
    ions_base.f90 
    kind.f90 
    lmdif.f90
    makov_payne.f90
    mdiis.f90 
    mm_dispersion.f90 
    mp_bands.f90 
    mp_exx.f90 
    mp_global.f90 
    mp_images.f90 
    mp_pools.f90 
    mp_wave.f90 
    mp_world.f90 
    noncol.f90 
    open_close_input_file.f90 
    parameters.f90 
    parser.f90 
    plugin_flags.f90 
    plugin_arguments.f90 
    plugin_variables.f90 
    printout_base.f90
    pw_dot.f90 
    qmmm.f90 
    random_numbers.f90 
    read_cards.f90 
    read_input.f90 
    read_namelists.f90 
    read_pseudo.f90 
    recvec.f90 
    recvec_subs.f90 
    run_info.f90 
    space_group.f90 
    set_para_diag.f90 
    set_signal.f90 
    set_vdw_corr.f90 
    setqf.f90 
    timestep.f90
    tsvdw.f90
    mbdlib.f90
    version.f90 
    wannier_gw.f90
    wannier_new.f90 
    wavefunctions.f90 
    ws_base.f90 
    xc_vdW_DF.f90 
    xc_rVV10.f90 
    io_base.f90 
    qes_types_module.f90 
    qes_libs_module.f90  
    qes_write_module.f90 
    qes_read_module.f90 
    qes_reset_module.f90 
    qes_init_module.f90 
    qes_bcast_module.f90 
    qexsd.f90   
    qexsd_copy.f90   
    qexsd_init.f90   
    qexsd_input.f90 
    hdf5_qe.f90
    qeh5_module.f90
    fox_init_module.f90 
    xsf.f90 
    wyckoff.f90 
    wypos.f90 
    zvscal.f90 
    wave_gauge.f90
    # list of RISM's modules
    allocate_fft_3drism.f90
    chempot.f90
    chempot_lauerism.f90
    closure.f90
    corrdipole_laue.f90
    correctat0_vv.f90
    corrgxy0_laue.f90
    cryst_to_car_2d.f90
    data_structure_3drism.f90
    do_1drism.f90
    do_3drism.f90
    do_lauerism.f90
    eqn_1drism.f90
    eqn_3drism.f90
    eqn_lauedipole.f90
    eqn_lauegxy0.f90
    eqn_lauelong.f90
    eqn_lauerism.f90
    eqn_laueshort.f90
    eqn_lauevoid.f90
    err_rism.f90
    guess_3drism.f90
    init_1drism.f90
    init_3drism.f90
    input_1drism.f90
    input_3drism.f90
    io_rism_xml.f90
    lauefft.f90
    lauefft_subs.f90
    lj_forcefield.f90
    lj_solute.f90
    molecorr_vv.f90
    molebridge_vv.f90
    molecule_const.f90
    molecule_types.f90
    mp_rism.f90
    mp_swap_ax_rism.f90
    normalize_lauerism.f90
    plot_rism.f90
    potential_3drism.f90
    potential_esm.f90
    potential_vv.f90
    print_chempot_3drism.f90
    print_chempot_lauerism.f90
    print_chempot_vv.f90
    print_corr_vv.f90
    print_solvavg.f90
    radfft.f90
    read_mol.f90
    read_solv.f90
    recvec_3drism.f90
    rism.f90
    rism1d_facade.f90
    rism3d_facade.f90
    rms_residual.f90
    scale_fft_3drism.f90
    scale_fft_lauerism.f90
    solute.f90
    solvation_3drism.f90
    solvation_esm.f90
    solvation_force.f90
    solvation_lauerism.f90
    solvation_pbc.f90
    solvation_stress.f90
    solvavg.f90
    solvmol.f90
    summary_1drism.f90
    summary_3drism.f90
    suscept_g0.f90
    suscept_laue.f90
    suscept_laueint.f90
    suscept_vv.f90
    write_rism_type.f90
    xml_io_rism.f90
    # subroutines and functions (not modules) previously found in flib
    atom_weight.f90 
    capital.f90 
    cryst_to_car.f90
    expint.f90 
    generate_k_along_lines.f90 
    more_functionals.f90 
    has_xml.f90 
    inpfile.f90 
    int_to_char.f90 
    latgen.f90 
    linpack.f90 
    matches.f90 
    plot_io.f90 
    radial_gradients.f90 
    rgen.f90 
    recips.f90 
    remove_tot_torque.f90
    sort.f90 
    trimcheck.f90 
    test_input_file.f90 
    date_and_tim.f90 
    volume.f90 
    wgauss.f90 
    w0gauss.f90
    w1gauss.f90
    deviatoric.f90
    # GPU
    random_numbers_gpu.f90)
qe_enable_cuda_fortran("${src_modules}")
qe_add_library(qe_modules ${src_modules})

# subroutines and functions (not modules) previously found in clib
set(src_modules_c
    customize_signals.c
    qmmm_aux.c
    sockets.c)
add_library(qe_modules_c ${src_modules_c})

if(TARGET gitrev)
   add_dependencies(qe_modules gitrev)
   target_compile_definitions(qe_modules PRIVATE HAVE_GITREV)
   target_include_directories(qe_modules PRIVATE ${qe_BINARY_DIR})
endif()

target_link_libraries(qe_modules
    PRIVATE
        qe_device_lapack  
        qe_modules_c
        qe_openmp_fortran
        qe_fftx
        qe_lax
        qe_mpi_fortran
        qe_mbd
        qe_xclib
        qe_devxlib
    PUBLIC
        qe_openacc_fortran
        qe_hdf5_fortran
        qe_upflib
        qe_fox
        qe_utilx
        qe_openacc_fortran)
if(QE_ENABLE_CUDA)
    target_link_libraries(qe_modules
        PRIVATE
            CUDA::curand)
endif()

if(QE_ENABLE_ENVIRON)
    target_link_libraries(qe_modules
    PUBLIC
        qe_environ)
endif()

###########################################################

qe_install_targets(qe_modules qe_modules_c)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=quantum-espresso
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=7.4
pkgrel=2
#_d3q_commit=de4718351e7bbb9d1d12aad2b7ca232d06775b83
_devxlib_commit=a6b89ef77b1ceda48e967921f1f5488d2df9226d
_fox_commit=3453648e6837658b747b895bb7bef4b1ed2eac40
_pw2qmcpack_commit=f72ab25fa4ea755c1b4b230ae8074b47d5509c70
#_qe_gipaw_commit=490046d300ec23444504bfad0562baa1c71f9345
pkgdesc="opEn-Source Package for Research in Electronic Structure, Simulation, and Optimization (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='http://www.quantum-espresso.org/'
msys2_repository_url="https://gitlab.com/QEF/q-e"
msys2_references=(
  'aur: quantum-espresso'
)
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libmbd"
         #"${MINGW_PACKAGE_PREFIX}-libxc"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-wannier90"
             #"${MINGW_PACKAGE_PREFIX}-environ"
             "git")
source=("https://gitlab.com/QEF/q-e/-/archive/qe-${pkgver}/q-e-qe-${pkgver}.tar.bz2"
        #"d3q::git+https://github.com/anharmonic/d3q#commit=${_d3q_commit}"
        "devxlib::git+https://gitlab.com/max-centre/components/devicexlib#commit=${_devxlib_commit}"
        "fox::git+https://github.com/pietrodelugas/fox#commit=${_fox_commit}"
        "pw2qmcpack::git+https://github.com/QMCPACK/pw2qmcpack#commit=${_pw2qmcpack_commit}"
        #"qe-gipaw::git+https://github.com/dceresoli/qe-gipaw#commit=${_qe_gipaw_commit}"
        "001-use-srand-instead-of-srandom.patch"
        "002-fix-build-devxlib-on-mingw.patch"
        "003-fix-install-c-libraries.patch"
        "004-fix-executable-suffix-on-mingw.patch")
sha256sums=('e17e7090b42db4687c5f304f8a47c3e90a0b05b6e345cdc54727465b5f0b2e33'
            'ef02c13a1ea73f38f0b81edd281c991c25bf045307ceb305f5c0f96b743d1556'
            '8625181b53f2b616a0f704507b4f2381f7b9fabe02078dfb74ab41ee11f5c260'
            'f0f5ebece3f0142e0d0b476db9547d8501de80259bc6409e9b108b887e4cc058'
            '2e18a13c194328516176c2bc2429ac230c9fc585381aa238e586b6034a7df0cb'
            'faaf147678e0c79a6678c5463dd5a466769257968275ef562f40ad1a0c2aacc6'
            'c889430a51d7b910723728c40ca73f183a93db58b1d03b02c6d7c98aea481e8b'
            '918cd94d6c770c88f59836ab4aedde749ac5e78da850556ad1a7acbf99109537')
noextract=("q-e-qe-${pkgver}.tar.bz2")

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  echo "Extracting q-e-qe-${pkgver}.tar.bz2..."
  tar -xjf q-e-qe-${pkgver}.tar.bz2 || true

  for _ext_prj in devxlib fox pw2qmcpack; do
    mv ${_ext_prj} q-e-qe-${pkgver}/external/
  done

  cd "${srcdir}"/q-e-qe-${pkgver}
  apply_patch_with_msg \
    001-use-srand-instead-of-srandom.patch \
    002-fix-build-devxlib-on-mingw.patch \
    003-fix-install-c-libraries.patch \
    004-fix-executable-suffix-on-mingw.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    export FFLAGS=" -Wno-missing-include-dirs -w"
  fi

  CFLAGS+=" -Wno-incompatible-pointer-types" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=OFF \
      -DQE_ENABLE_FOX=ON \
      -DQE_ENABLE_HDF5=ON \
      -DQE_ENABLE_OPENMP=ON \
      -DQE_ENABLE_ENVIRON=OFF \
      -DQE_ENABLE_LIBXC=OFF \
      -DQE_ENABLE_MPI=OFF \
      -DQE_ENABLE_TEST=OFF \
      -DQE_ENABLE_PLUGINS="pw2qmcpack;legacy" \
      -DQE_DEVICEXLIB_INTERNAL=ON \
      -DQE_FOX_INTERNAL=ON \
      -DQE_MBD_INTERNAL=OFF \
      -DQE_WANNIER90_INTERNAL=OFF \
      -DQE_FFTW_VENDOR="FFTW3" \
      -DBLA_VENDOR=OpenBLAS \
      -S q-e-qe-${pkgver} \
      -B build-${MSYSTEM}

  "${MINGW_PREFIX}"/bin/cmake.exe --build build-${MSYSTEM}
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install build-${MSYSTEM}

  install -Dm644 "${srcdir}"/q-e-qe-${pkgver}/License \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/qe/*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done

  # Rename cp to qe_cp, to not be used instead of /usr/bin/cp to copy files 
  mv "${pkgdir}${MINGW_PREFIX}"/bin/{cp,qe_cp}.exe
}
